Index: lemon/bits/graph_extender.h
===================================================================
--- lemon/bits/graph_extender.h	(revision 2098)
+++ lemon/bits/graph_extender.h	(revision 2102)
@@ -190,5 +190,5 @@
     /// \brief Base node of the iterator
     ///
-    /// Returns the base node (ie. the source in this case) of the iterator
+    /// Returns the base node (i.e. the source in this case) of the iterator
     Node baseNode(const OutEdgeIt &e) const {
       return Parent::source(e);
@@ -196,5 +196,5 @@
     /// \brief Running node of the iterator
     ///
-    /// Returns the running node (ie. the target in this case) of the
+    /// Returns the running node (i.e. the target in this case) of the
     /// iterator
     Node runningNode(const OutEdgeIt &e) const {
@@ -204,5 +204,5 @@
     /// \brief Base node of the iterator
     ///
-    /// Returns the base node (ie. the target in this case) of the iterator
+    /// Returns the base node (i.e. the target in this case) of the iterator
     Node baseNode(const InEdgeIt &e) const {
       return Parent::target(e);
@@ -210,5 +210,5 @@
     /// \brief Running node of the iterator
     ///
-    /// Returns the running node (ie. the source in this case) of the
+    /// Returns the running node (i.e. the source in this case) of the
     /// iterator
     Node runningNode(const InEdgeIt &e) const {
Index: lemon/list_graph.h
===================================================================
--- lemon/list_graph.h	(revision 2098)
+++ lemon/list_graph.h	(revision 2102)
@@ -317,6 +317,6 @@
   ///This is a simple and fast erasable graph implementation.
   ///
-  ///It addition that it conforms to the
-  ///\ref concept::ErasableGraph "ErasableGraph" concept,
+  ///It conforms to the
+  ///\ref concept::ErasableGraph "ErasableGraph" concept and
   ///it also provides several additional useful extra functionalities.
   ///\sa concept::ErasableGraph.
@@ -331,7 +331,7 @@
     /// Changes the target of \c e to \c n
     ///
-    ///\note The <tt>Edge</tt>'s and <tt>OutEdge</tt>'s
+    ///\note The <tt>Edge</tt>s and <tt>OutEdge</tt>s
     ///referencing the changed edge remain
-    ///valid. However <tt>InEdge</tt>'s are invalidated.
+    ///valid. However <tt>InEdge</tt>s are invalidated.
     void changeTarget(Edge e, Node n) { 
       _changeTarget(e,n); 
@@ -341,7 +341,7 @@
     /// Changes the source of \c e to \c n
     ///
-    ///\note The <tt>Edge</tt>'s and <tt>InEdge</tt>'s
+    ///\note The <tt>Edge</tt>s and <tt>InEdge</tt>s
     ///referencing the changed edge remain
-    ///valid. However <tt>OutEdge</tt>'s are invalidated.
+    ///valid. However <tt>OutEdge</tt>s are invalidated.
     void changeSource(Edge e, Node n) { 
       _changeSource(e,n);
@@ -350,7 +350,7 @@
     /// Invert the direction of an edge.
 
-    ///\note The <tt>Edge</tt>'s
+    ///\note The <tt>Edge</tt>s
     ///referencing the changed edge remain
-    ///valid. However <tt>OutEdge</tt>'s  and <tt>InEdge</tt>'s are invalidated.
+    ///valid. However <tt>OutEdge</tt>s  and <tt>InEdge</tt>s are invalidated.
     void reverseEdge(Edge e) {
       Node t=target(e);
@@ -359,7 +359,7 @@
     }
 
-    ///Using this it possible to avoid the superfluous memory allocation.
-
-    ///Using this it possible to avoid the superfluous memory allocation.
+    ///Using this it is possible to avoid the superfluous memory allocation.
+
+    ///Using this it is possible to avoid the superfluous memory allocation.
     ///\todo more docs...
     void reserveEdge(int n) { edges.reserve(n); };
@@ -370,5 +370,5 @@
     ///
     ///Node \p b will be removed but instead of deleting
-    ///its neighboring edges, they will be joined to \p a.
+    ///incident edges, they will be joined to \p a.
     ///The last parameter \p r controls whether to remove loops. \c true
     ///means that loops will be removed.
@@ -376,5 +376,5 @@
     ///\note The <tt>Edge</tt>s
     ///referencing a moved edge remain
-    ///valid. However <tt>InEdge</tt>'s and <tt>OutEdge</tt>'s
+    ///valid. However <tt>InEdge</tt>s and <tt>OutEdge</tt>s
     ///may be invalidated.
     void contract(Node a, Node b, bool r = true) 
@@ -407,5 +407,5 @@
     ///\note The <tt>Edge</tt>s
     ///referencing a moved edge remain
-    ///valid. However <tt>InEdge</tt>'s and <tt>OutEdge</tt>'s
+    ///valid. However <tt>InEdge</tt>s and <tt>OutEdge</tt>s
     ///may be invalidated.
     ///\warning This functionality cannot be used together with the Snapshot
@@ -427,10 +427,10 @@
     ///Split an edge.
 
-    ///This function splits an edge. First a new node \c b is added to the graph,
-    ///then the original edge is re-targetes to \c b. Finally an edge
-    ///from \c b to the original target is added.
-    ///\return The newly created node.
-    ///\warning This functionality cannot be used together with the Snapshot
-    ///feature.
+    ///This function splits an edge. First a new node \c b is added to
+    ///the graph, then the original edge is re-targeted to \c
+    ///b. Finally an edge from \c b to the original target is added.
+    ///\return The newly created node.  
+    ///\warning This functionality
+    ///cannot be used together with the Snapshot feature.
     Node split(Edge e) 
     {
@@ -441,7 +441,7 @@
     }
       
-    ///Class to make a snapshot of the graph and to restrore to it later.
-
-    ///Class to make a snapshot of the graph and to restrore to it later.
+    ///Class to make a snapshot of the graph and to restore  it later.
+
+    ///Class to make a snapshot of the graph and to restore  it later.
     ///
     ///The newly added nodes and edges can be removed using the